% oscilator sa Vinovim mostom
% ustaljeno stanje, THD

load "T"
load "ic2"

astop = T*2*pi;
atstep = 0.05*pi/180;

nstep = astop/atstep;
nstep=ceil(nstep);
astep=astop/nstep;

h = astep;

load "ic2"

vc1(1)=ic2(1);
vc2(1)=ic2(2);

c1=1;
c2=2;

while c1 < nstep

	vo(c1)=vout(vc1(c1));
	vc1(c2)=vc1(c1)+h*(-2*vc1(c1)-vc2(c1)+vo(c1));
	vc2(c2)=vc2(c1)+h*(-vc1(c1)-vc2(c1)+vo(c1));
	
	c1=c2;
	c2=c2+1;
	
end

vo(c1)=vout(vc1(c1));

icstart=[ic2(1) ic2(2) vout(ic2(1))]
icstop=[vc1(c1) vc2(c1) vout(vc1(c1))]
dic=icstop-icstart

n=nstep-1;
i=1:n;
wt=i*2*pi/n;
si=sin(wt);
co=cos(wt);
vt=vo(1:n);
Vout1cm=sum(co.*vt)*2/n;
Vout1sm=sum(si.*vt)*2/n;
Vout1m=sqrt(Vout1cm^2+Vout1sm^2)
Vout1=Vout1m/sqrt(2)
Voutrms=sqrt(mean(vt.*vt))
THD=sqrt(Voutrms^2-Vout1^2)/Vout1*100

ssdat=[Vout1m Vout1 Voutrms THD];
save ssdat ssdat

